#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <unistd.h>

#define ATTEMPTS 10
#define SLEEP 100000

int fd;
char *buff,*buffer,*bufptr;
char buf[1024];
int rd, tries;

int main( int argc, char ** argv ) {
	if( argc != 4 ) {
		printf( "USAGE: command <command> <bytes to read> <output format>" );
		printf( "  format could be 1=string, 2=number" );
		return 2;
	}
	fd = open( "/dev/tts/1", O_RDWR | O_NOCTTY | O_NDELAY );
	if( fd == -1 ) {
//printf("a" );
		printf( "-1" );
		return 1;
	} else {
		fcntl( fd, F_SETFL,O_NONBLOCK );
//printf( "b" );
		rd = 1;
//printf( "c" );
		tries = 0;
		while( ( rd != -1 ) && ( tries < ATTEMPTS ) ) {
//printf( "d" );
			rd = read( fd, buf, 1 );
			usleep( SLEEP );
			tries++;
		}
//printf( "e" );
		rd = -1;
		tries = 0;
//printf( "f" );
    sprintf( buf, "%s\n", argv[1] );
		while( ( rd == -1 ) && ( tries < ATTEMPTS ) ) {
//printf( "l" );
			write( fd, buf, strlen( argv[1] ) + 1 );
			if( atoi( argv[2] ) == 0 ) {
				return 0;
			}
			//write( fd, "\r", 1 );
//printf( "g" );
			usleep( SLEEP );
//printf( "j" );
			rd = read( fd, buf, atoi( argv[2] ) );
//printf( "k" );
			tries++;
		}
//printf( "h" );
		if( tries >= ATTEMPTS ) {
//printf( "Max attempts exceeded\n" );
			printf( "-1" );
			return 3;
		}
//printf( "i" );
		buf[rd] = 0;
		if( !strcmp( argv[3], "1" ) ) {
			printf( "%s", buf );
		} else if( !strcmp( argv[3], "2" ) ) {
			printf( "%d", buf[0] );
		} else {
			printf( "Unknown format." );
		}
		close( fd );
		return 0;
	}
}
