var WEB_CAMERA_IP="192.168.1.107";
var img = new Image();
var timer = -1;
var fast = 200;
var slow = 80;
var regExp = /<\/?[^>]+>/gi;
var old_square = "9_7";

function urlencode(str) {
	str = escape(str);
	str = str.replace('+', '%2B');
	str = str.replace('%20', '+');
	str = str.replace('*', '%2A');
	str = str.replace('/', '%2F');
	str = str.replace('@', '%40');
	return str;
}

function cmd( cmd, timed )
{
	var d = new Date();
	//alert( cmd );
	//img.
	document.getElementById( "cmd_output" ).src = "/cgi-bin/do.cgi?action=" + urlencode( cmd );
	if( document.getElementById( 'copy' ).checked )
	{
		if( timer > 0 )
		{
			document.getElementById( 'code' ).value += "usleep " + ( d.valueOf() - timer ) * 1000 + "\n";
		}
		document.getElementById( 'code' ).value += cmd + "\n";
	}
	// uncomment the next line for debug purposes. Comment for product
	//location.href = "/cgi-bin/do.cgi?action="+cmd;
	if( timed )
	{
		timer = d.valueOf();
	}
	else
	{
		timer = -1;
	}
}

function stripTags(xStr){
	xStr = xStr.replace(regExp,"");
	return xStr;
}

function loadProgram( file )
{
	document.getElementById( 'buffer' ).src = file;
	//alert(top.frames['buffer'].document.body.innerHTML);
	//var loc=top.frames['buffer'].location.href.split('/');
	//var loc=loc[loc.length-1];
	var loc = top.frames['buffer'].location.href;
	//alert ( loc + ' ---- ' + document.getElementById('buffer').src );
	var pathloc = loc.substr(loc.indexOf('/',8));
	if((document.getElementById('buffer').src != loc) && (document.getElementById('buffer').src != pathloc))
	{
		setTimeout( 'loadProgram( \'' + file + '\' )', 100 );
	}
	else
	{
		document.getElementById( 'code' ).value = stripTags( top.frames['buffer'].document.body.innerHTML );
	}
}

function saveProgram( file )
{
	document.getElementById( 'post_form_action' ).value = 'save_program';
	document.getElementById( 'post_form_file' ).value = file;
	document.getElementById( 'post_form_content' ).value = toLinux( document.getElementById( 'code' ).value );
	document.post_form.submit();
}

function toggle( pwm, name )
{
  chk = document.getElementById( name );
	if( chk.checked )
	{
			cmd( "on " + pwm );
	}
	else
	{
			cmd( "off " + pwm );
	}
}

function runProgram()
{
	document.getElementById( 'post_form_action' ).value = 'run_program';
	document.getElementById( 'post_form_file' ).value = "";
	document.getElementById( 'post_form_content' ).value = toLinux( document.getElementById( 'code' ).value );
	document.post_form.submit();
}

function initProgram( file )
{
	document.getElementById( 'post_form_action' ).value = 'init_program';
	document.getElementById( 'post_form_file' ).value = "";
	document.getElementById( 'post_form_content' ).value = "";
	document.post_form.submit();
}

function lookAt( y, x )
{
	document.getElementById( old_square ).src = "images/blue-square.gif";
	old_square = y + "_" + x;
	document.getElementById( old_square ).src = "images/red-square.gif";
	cmd( "lookat " + x + " " + y + " " + 14 + " " + 10, false );
	return true;
}

function hideAll() {
	document.getElementById( 'roam' ).style.display = 'none';
	document.getElementById( 'roam_div' ).className  = 'menu';
	document.getElementById( 'program' ).style.display = 'none';
	document.getElementById( 'program_div' ).className  = 'menu';
	document.getElementById( 'settings' ).style.display = 'none';
	document.getElementById( 'settings_div' ).className  = 'menu';
	document.getElementById( 'debug' ).style.display = 'none';
	document.getElementById( 'debug_div' ).className  = 'menu';
	document.getElementById( 'help' ).style.display = 'none';
	document.getElementById( 'help_div' ).className  = 'menu';
}

function rezoom()
{
	change_zoom(0);
	change_zoom(1);
	change_zoom(1);
}

function fillCameraField( width, height, center_x, center_y )
{
	var field = document.getElementById( "camera_field" );
	var str = '<table border="0" cellspacing="0" cellpadding="0" class="camera">';
	var i, j;
	for( j = height; j >= 0; j-- )
	{
		str += '<tr>';
		for( i = 0; i <= width; i++ )
		{
				if( j == center_x && i == center_y )
				{
					str += '<td><a onclick="return lookAt( '+ j + ', ' + i + ' )"><img src="images/red-square.gif" border="0" id="' + j + '_' + i + '" alt="X" title="[' + j + ';' + i + ']" style="border: 1px solid #000000"></a></td>';
				}
				else
				{
					str += '<td><a onclick="return lookAt( '+ j + ', ' + i + ' )"><img src="images/blue-square.gif" border="0" id="' + j + '_' + i + '" alt="X" title="[' + j + ';' + i + ']"></a></td>';
				}
		}
		str += '</tr>';
	}
	str += '</table>';
	field.innerHTML = str;
}

function initialize() {
	loadProgram( '/code/tmp.txt' );
	hideAll();
	switchTo('roam');
	fillCameraField( 14, 10, 4, 7 );
	///connect(9001);
	//setTimeout( "rezoom()", 1000 );
}

function switchTo( mode ) {
	hideAll();
	document.getElementById( mode ).style.display = 'block';
	document.getElementById( mode+'_div' ).className  = 'selected_menu';
}

function configureNetwork() {
	mode = document.getElementById( 'mode' ).value;
	ssid = document.getElementById( 'ssid' ).value;
	wepkey = document.getElementById( 'wepkey' ).value;
	if( ( mode == 'ap' || mode == 'sta' ) && wepkey.length != 26 ) {
		alert( "The WEP Key must be exactly 26 characters long" );
	//} else if( ( mode == 'ap' || mode == 'sta' ) && ssid.indexOf ) { // TODO: later. More checks on ssid and wepkey, like no space and special chars
	//	alert( "The WEP Key must be exactly 26 characters long" );
	}	else {
		cmd( "reconfigure_router " + mode + " " + ssid + " " + wepkey + "" ); // TODO: insecure!
		showWaitWindow( 'Please wait the system is reconfiguring now', 17000 );
	}
}

function poweroff() {
	disableConfigButtons();
	cmd( "poweroff_robot" );
	showWaitWindow( 'The routerbot is shutting down. Please turn it on and reload this page to use this web interface', 100000000 );
}

function reboot() {
	disableConfigButtons();
	cmd( "reboot_robot" );
	showWaitWindow( 'Please wait the system is rebooting now', 15000 );
}

function showWaitWindow( msg, timeout ) {
	ww = document.getElementById( 'wait_window' );
	ww.innerHTML = "<h2>" + msg + "</h2>";
	ww.style.display = 'block';
	setTimeout( 'hideWaitWindow()', timeout );
}

function hideWaitWindow() {
	ww = document.getElementById( 'wait_window' );
	ww.style.display = 'none';
	enableConfigButtons();
}

function disableConfigButtons() {
	document.getElementById( "reboot" ).disabled = true;
	document.getElementById( "poweroff" ).disabled = true;
	document.getElementById( "configure" ).disabled = true;
}

function enableConfigButtons() {
	document.getElementById( "reboot" ).disabled = false;
	document.getElementById( "poweroff" ).disabled = false;
	document.getElementById( "configure" ).disabled = false;
}

function toLinux( str ) {
	return str;
	//return str.replace( /\r/g, ";" ).replace( /\n/g, ";" );
}